/*
 * svs.c - Simple Void Stack
 * 
 * Shut up. It does the job.
 * 
 * $Id: svs.c,v 1.2 2002/11/13 17:24:57 rharris Exp $
 */

#include <stdio.h>
#include "svs.h"

#define DEBUG

#define SVS_MAX_SIZE 64
static void    *svs_array[SVS_MAX_SIZE];

static int      svs_height = 0;

void 
svs_clear()
{
    svs_height = 0;
}

int 
svs_size()
{
    return svs_height;
}

int
svs_push(void *in)
{
    if (svs_height == SVS_MAX_SIZE)
	return 0;

    if (!in)
	return -1;

    svs_array[svs_height++] = in;
    return 1;
}

int
svs_pop(void **out)
{
    if (svs_height == 0)
	return 0;

    *out = svs_array[--svs_height];
    return 1;

}

int
svs_peek(void **ptr)
{

    if (svs_height == 0)
	return 0;

    *ptr = svs_array[svs_height - 1];
    return 1;
}
